/*
   program : recon

   $Source: /home/yee/C/RCS/backproject.h,v $
   $Author: yee $
   $Date: 1999/03/09 01:52:38 $
   $Revision: 1.29 $

   Parameters : none

   Assumptions : none known

   Bugs : none known

   To Do :
     1) Check to make sure that all of the elements of the finite
        state machine need to return double.  Probably quite a
        few can return void.

   $Log: backproject.h,v $
   Revision 1.29  1999/03/09 01:52:38  yee
   *** empty log message ***

   Revision 1.28  1999/02/10 16:39:47  yee
   *** empty log message ***

   Copyright 1997,1998,1999 by Conway Yee.  All rights reserved.
 */

/*****************************************************************************/

#include "mutil.h"
#include "ImageHeader.h"
#include "recon.h"

#ifndef BACKPROJECT_H
#define BACKPROJECT_H

  typedef struct BackprojectFunctions {
    double (* BackprojectionFilterWeight)();
    double (* ProjectionWeight)();
    void   (* BackprojectProjection)();
    double (* BackprojectPoint)();
    double (* BackprojectNormalize)();
  } BackprojectFunctions;
 
  PUBLIC void FilteredBackproject(ImageHeader *,ImageHeader *,double (*)());
  PUBLIC double BasicBackprojectionFilter(int,int,double *);

/*********** functions below called only from within backproject.c ***********/

#ifdef RECON_PARALLEL_NATIVE
    PUBLIC void ParallelBackprojectProjection(RECON_FLOAT **,int *,double *,
                      RECON_COMPLEX *,int *,double *,double,double,double,
                      double,BackprojectFunctions *);
#endif RECON_PARALLEL_NATIVE

#ifdef RECON_PARALLEL_FAN
    PUBLIC double ParallelBackprojectPoint(double,double,double *,double *,
                                           double,double,double);
    PUBLIC double P2(double,double,double,double,double);
    PUBLIC double ParallelBackprojectionFilterWeight(int,int,void *);
    PUBLIC double ParallelProjectionWeight(int,int,void *);
#endif RECON_PARALLEL_FAN

#ifdef RECON_ANGLE_FAN
    PUBLIC double AngleBackprojectPoint(double,double,double *,double *,
                                        double,double,double);
    PUBLIC double L2(double,double,double,double,double);
    PUBLIC double AngleBackprojectionFilterWeight(int,int,double *);
    PUBLIC double AngleProjectionWeight(int,int,double *);
#endif RECON_ANGLE_FAN

#ifdef RECON_COLIN_FAN
    PUBLIC double ColinBackprojectPoint(double,double,double *,double *,
                                        double,double,double);
    PUBLIC double U2(double,double,double,double,double);
    PUBLIC double ColinBackprojectionFilterWeight(int,int,void *);
    PUBLIC double ColinProjectionWeight(int,int,double *);
#endif RECON_COLIN_FAN
#endif BACKPROJECT_H
